// (C) 1996 Dave Wallin
// This source code is messy and is provided only for your own enjoyment..
// I make no claims about the function of this program, and am not responsible
// if it deletes your hard drive, kills your family, makes your dog sick,
// or anything else bad.. You may not make a derivitive work on this
// source code.. Anything resembling this work is my property..
// Now, have fun... :)

#include <io.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <malloc.h>
#include <string.h>
#include <graph.h>
#include <gdata.h>
#include <ggraph.h>
#include <pcx.h>
#include <gkey.h>
#include <keys.h>
#include <cret.h>
#include <cgraph.h>

// Globals //
unsigned int far *clock = (unsigned int far *) 0x0000046C;  // Location of the internal
                                                            // clock which runs at 18.2 ticks per second
int cursor_x=160, cursor_y=10;
float speed=1;      // Variable used to speed up or slow down the game based on machine speed.

#define DEBUG 0

// Prototypes //
void Init_Crets();
int Chance(int val);
int Num_Crets();
void Make_Food(fixed x, fixed y);
void Draw_Crets();
void Update_Crets();
void Set_State(int c, int state);
int Make_Cret();
void Think(int c);      // Pick a new state or carry out the current state

void Init_Crets()
{
    int c;
        memset(cret, 0, sizeof(cret));
    for(c=0; c<NUMCREATURES; c++)
    {
        cret[c].alive = NO;
        cret[c].hpx = -1;
        cret[c].target_a = -1;
        cret[c].target_b = -1;
    }
}

int Num_Crets() // counts the number of creatures
{
    int c, count=0;

    for(c=0; c<NUMCREATURES; c++)
    if(cret[c].alive == YES)
        count ++;

    return count;
}

// this function makes a creature which will behave according to the personality
// variables you assign it.
int Make_Cret(int x, int y, int hpx, int pers, int fear, int str, int att, int hid, int cng, int wrd)
{
    int c, cur_act, t;

    for(c=0; c<NUMCREATURES; c++)
    if(cret[c].alive == NO)
    {
        cret[c].alive = YES;
        cret[c].x = (fixed)x<<8;
        cret[c].y = (fixed)y<<8;
        cret[c].xv = 0;
        cret[c].yv = 0;
        cret[c].angle = 0;
        cret[c].score = 0;
        cret[c].hpx = hpx;
        cret[c].pers = pers;
        cret[c].fear = fear;
        cret[c].str = str;
        cret[c].eat_time = 0;
        Set_State(c, STATE_WAIT);
        cur_act = 0;
        t = cur_act+att;
        for(; cur_act<t; cur_act++)
            cret[c].actions[cur_act] = ACT_HUNT;
        t = cur_act+att;
        for(; cur_act<t; cur_act++)
            cret[c].actions[cur_act] = ACT_CONG;
        t = cur_act+att;
        for(; cur_act<t; cur_act++)
            cret[c].actions[cur_act] = ACT_HIDE;
        t = cur_act+att;
        for(; cur_act<t; cur_act++)
            cret[c].actions[cur_act] = ACT_WIERD;
        for(; cur_act<NUMACTS; cur_act++)
            cret[c].actions[cur_act] = ACT_NOTHING;
        return c;
    }
}


int Pick_New_State(int c)
{
    int x, new_act;
    point centr;
    x = rand()%NUMACTS;
    new_act = cret[c].actions[x];

    switch(new_act)
    {
        case ACT_NOTHING :
            Set_State(c, STATE_WAIT);
        break;
        case ACT_HUNT :
            Set_State(c, STATE_HUNT);
            cret[c].target_a = (long)Find_Closest_Cret(c);
            if(cret[c].target_a == -1)
                Set_State(c, STATE_WAIT);
        break;
        case ACT_CONG :
            Set_State(c, STATE_MOVE);
            Centroid();
//            printf("\n%d is congregating at %d, %d", c, (int)(gx>>8), (int)(gy>>8));
//            double_buffer[(centr.x>>8) + (unsigned int)(centr.y) + (centr.y>>2)]=100;
            cret[c].target_a = gx;
            cret[c].target_b = gy;
        case ACT_HIDE :
            Set_State(c, STATE_MOVE);
            Centroid();
            cret[c].target_a = cret[c].x + (gx - cret[c].x);
            cret[c].target_b = cret[c].y + (gy - cret[c].y);
        break;
        default:
            Set_State(c, STATE_WAIT);
        break;

    }
}

void Move_Cret(int c, fixed target_x, fixed target_y, float accel)
{
    int ang;
    fixed cs, sn;
    double dx, dy, dist;
    accel = accel/speed;
        dx = (target_x - cret[c].x)/256;
        dy = (target_y - cret[c].y)/256;
        dist = sqrt(dx*dx + dy*dy);
        if(dist > 0)
        {
            cs = (fixed)((dx*256)/dist);
            sn = (fixed)((dy*256)/dist);
            ang = calc_angle(cs, sn);

            cret[c].angle = ang;

            if(cret[c].angle < 0) cret[c].angle +=1919;
            if(cret[c].angle > 1919) cret[c].angle -=1919;

            cret[c].xv += (cos_table[cret[c].angle]*accel);
            cret[c].yv += (sin_table[cret[c].angle]*accel);
        }
}

int Chance(int val)
{
    int x = rand()%100;
    if(x < val) return YES;
    else return NO;
}

void Think(int c)
{
    int state, ang, ang2, d1, d2, targ;
    long cs, sn;
    double dist, dx, dy;

    state = cret[c].cur_state;
    targ = Find_Closest_Cret(c);

    if(cret[c].cur_state == STATE_WAIT)                     // If not attacking
    if(targ != -1)                                          // If there actually is a creature to be afraid of
    if( vec_len((cret[c].x - cret[targ].x),                 // If creature is close
             (cret[c].y - cret[targ].y)) < K_CRETNEARBY)
    if(Chance(cret[c].fear))                                // If this creature is wary and the chance that he notices
    {
       Set_State(c, STATE_RUN);
       cret[c].target_a = (long)targ;
    }

    if(cret[c].counter > (700*speed))               // If the creature has been doing anything for a long time, he gets bored
                Set_State(c, STATE_WAIT);

    switch(state)
    {
        case STATE_WAIT :
            if(cret[c].counter > (20*speed))
            Pick_New_State(c);
        break;
        case STATE_RUN :
            if(cret[c].counter > (200*speed)) {               // If the creature has been doing anything for a long time, he gets bored
                Set_State(c, STATE_WAIT);
                break;
            }

            targ = (int)cret[c].target_a;
            if( vec_len((cret[c].x - cret[targ].x),                 // If creature is close
                (cret[c].y - cret[targ].y)) > K_CRETNEARBY+500) {
                    Set_State(c, STATE_WAIT);
                    break;
                }

            if(cret[targ].alive == NO || targ == -1 || cret[c].counter > (100*speed))
            {
                Set_State(c, STATE_WAIT);
                break;
            }
            else Move_Cret(c, cret[c].x + (cret[c].x - cret[targ].x),
                              cret[c].y + (cret[c].y - cret[targ].y), K_CRET_MOV);

        break;
        case STATE_DYING :
            if(cret[c].counter > (35*speed)) {
                cret[c].hpx = -1;
                cret[c].alive = NO;
            }
        break;
        case STATE_MOVE :
            if(cret[c].counter > (50*speed)) {               // If the creature has been doing anything for a long time, he gets bored
                Set_State(c, STATE_WAIT);
                break;
            }
            Move_Cret(c, cret[c].target_a, cret[c].target_b, K_CRET_MOV);
            if(vec_len(cret[c].target_a - cret[c].x,
                       cret[c].target_b - cret[c].y) < K_EATRANGE)  // Reached goal
                Set_State(c, STATE_WAIT);
        break;
        case STATE_SQUASHW :
//            sound(OUCH!)
        break;
        case STATE_HUNT :
            targ = (int)cret[c].target_a;
            if(cret[targ].alive == NO || targ == -1) {
                Set_State(c, STATE_WAIT);
                break;
            }

            Move_Cret(c, cret[targ].x, cret[targ].y, K_CRET_EATSPEED + (float)cret[c].str/50);
            if(vec_len(cret[targ].x - cret[c].x,
                       cret[targ].y - cret[c].y) < K_EATRANGE)
                Set_State(c, STATE_EAT);
//                printf("Eating..");
        break;
        case STATE_EAT :
            targ = (int)cret[c].target_a;
            // Slow down..
            if(cret[c].cur_frame == 1)
            if( vec_len((cret[targ].x - cret[c].x), (cret[targ].y - cret[c].y))
                                                < K_EATRANGE )
            {
                cret[targ].hpx -= cret[c].str;
                if(cret[targ].hpx <= 0) {
                    cret[c].score += K_EATPOINTS;
                    cret[targ].score = 0;
                    cret[targ].alive = NO;
                    cret[c].eat_time = 0;
                    if(Chance(70))              // 70% Chance that he will lick his lips
                    Set_State(c, STATE_YUMM);
                }
            }
            else
            {
                if( Chance(cret[c].pers) ) {
                    Set_State(c, STATE_HUNT);  // If the attack failed, go after him again
                }
                else Set_State(c, STATE_WAIT);
            }
        break;
    }
}


void Set_State(int c, int state)
{
    cret[c].frame_time = 0;
    cret[c].cur_frame = 0;
    cret[c].cur_state = state;
    cret[c].counter = 0;
    switch(state) {
        case STATE_WAIT :
            cret[c].frame.num_frames = 0;
            cret[c].frame.delay = 10;
            cret[c].frame.repeats = YES;
            cret[c].frame.pic[0] = 0;
            cret[c].frame.pic[1] = 0;
            break;
        case STATE_MOVE :
            cret[c].frame.num_frames = 2;
            cret[c].frame.delay = 4;
            cret[c].frame.repeats = YES;
            cret[c].frame.pic[0] = 1;
            cret[c].frame.pic[1] = 2;
            cret[c].frame.pic[2] = 4;
            break;
        case STATE_RUN :
            cret[c].frame.num_frames = 2;
            cret[c].frame.delay = 4;
            cret[c].frame.repeats = YES;
            cret[c].frame.pic[0] = 1;
            cret[c].frame.pic[1] = 2;
            cret[c].frame.pic[2] = 4;
            break;
        case STATE_HUNT :
            cret[c].frame.num_frames = 2;
            cret[c].frame.delay = 2;
            cret[c].frame.repeats = YES;
            cret[c].frame.pic[0] = 0;
            cret[c].frame.pic[1] = 1;
            cret[c].frame.pic[2] = 4;
            break;
        case STATE_DYING :
            cret[c].frame.num_frames = 0;
            cret[c].frame.delay = 40;
            cret[c].frame.repeats = YES;
            cret[c].frame.pic[0] = 5;
            break;
        case STATE_EAT :
            cret[c].frame.num_frames = 2;
            cret[c].frame.delay = 10;
            cret[c].frame.repeats = NO;
            cret[c].frame.pic[0] = 4;
            cret[c].frame.pic[1] = 2;
            cret[c].frame.pic[2] = 0;
            break;
        case STATE_ISFOOD :
            cret[c].frame.num_frames = 0;
            cret[c].frame.delay = 0;
            cret[c].frame.repeats = YES;
            cret[c].frame.pic[0] = 6;
            break;
        case STATE_SQUASHW :
            cret[c].frame.num_frames = 0;
            cret[c].frame.delay = 20;
            cret[c].frame.repeats = NO;
            cret[c].frame.pic[0] = 4;
            break;
        case STATE_SQUASH :
            cret[c].frame.num_frames = 0;
            cret[c].frame.delay = 20;
            cret[c].frame.repeats = NO;
            cret[c].frame.pic[0] = 17;
            break;
        case STATE_YUMM :
            cret[c].frame.num_frames = 2;
            cret[c].frame.delay = 20;
            cret[c].frame.repeats = NO;
            cret[c].frame.pic[0] = 20;
            cret[c].frame.pic[1] = 19;
            cret[c].frame.pic[2] = 21;
            break;

        }
}
void Debug()
{
    int c;
    _settextposition(1,1);
    for(c=0; c<NUMCREATURES; c++)
        if(cret[c].alive == YES) {
            printf("\nCret %d", c);
            printf("\nTarget_a = %l", cret[c].target_a);
            printf("\nTarget_b = %l", cret[c].target_b);
            printf("\nState : %d", cret[c].cur_state);
            printf("\n----");
        }
}
void Update_Crets()
{
    int c;
    fixed len;
    for(c=0; c<NUMCREATURES; c++)
        if(cret[c].alive == YES) {
            if(cret[c].hpx <= 0) {
                Set_State(c, STATE_DYING);
//                cret[c].alive = NO;
                break;
            }

        // Perform AI functions....
            Think(c);
            len = vec_len(cret[c].xv, cret[c].yv);
            if(len > K_CRET_TOPSPEED)
            {
                cret[c].xv = (cret[c].xv*K_CRET_TOPSPEED)/len;
                cret[c].yv = (cret[c].yv*K_CRET_TOPSPEED)/len;
            }
            cret[c].x += cret[c].xv;
            cret[c].y += cret[c].yv;

            // creture bumped into a wall
            if(cret[c].x < (fixed)20<<8) {
                cret[c].x = (fixed)20<<8;
                cret[c].xv = -cret[c].xv*K_CRET_ELASTICITY;
                if(cret[c].cur_state != STATE_SQUASHW) {
                    cret[c].target_b = (long)cret[c].cur_state;
                    Set_State(c, STATE_SQUASHW);
                }
            }
            if(cret[c].x > (fixed) 300<<8) {
                cret[c].x = (fixed)300<<8;
                cret[c].xv = -cret[c].xv*K_CRET_ELASTICITY;
                Set_State(c, STATE_SQUASHW);

            }
            // Bumped into floor
            if(cret[c].y > (fixed)190<<8) {
                cret[c].y = (fixed)190<<8;
                cret[c].yv = (-cret[c].yv*K_CRET_ELASTICITY)-50;
                Set_State(c, STATE_WAIT);
//                if(cret[c].cur_state != STATE_SQUASH) {
//                    cret[c].target_b = (long)cret[c].cur_state;
//                    Set_State(c, STATE_SQUASH);
//                }
            }
            if(cret[c].y > (fixed)40<<8) {      // If creature is in water
                cret[c].xv -= (cret[c].xv*K_WATER_FRICTION);
                cret[c].yv -= (cret[c].yv*K_WATER_FRICTION);
                cret[c].yv += K_GRAV_WATER;
            }
            // If out of water..
            if(cret[c].y <= (fixed)40<<8)
                cret[c].yv += K_GRAV;

//            cret[c].eat_time++;
//            if(cret[c].eat_time > K_CRETHUNGRY*speed)
//                if(cret[c].cur_state != STATE_EAT)
//                    Set_State(c, STATE_EAT);
//            if(cret[c].eat_time > K_CRETHUNGDED*speed)
//                if(cret[c].cur_state != STATE_DYING)
//                    Set_State(c, STATE_DYING);

            cret[c].counter++;
            cret[c].frame_time++;

            if(cret[c].frame_time > (cret[c].frame.delay * speed) ) {
                cret[c].cur_frame++;
                cret[c].frame_time = 0;
            }
            if(cret[c].cur_frame > cret[c].frame.num_frames)
            if(cret[c].frame.repeats == YES)
                cret[c].cur_frame=0;
            else
                Set_State(c, STATE_WAIT);

            if(cret[c].angle > 1919) cret[c].angle -= 1919;
            if(cret[c].angle < 0) cret[c].angle += 1919;


        }
}


void Draw_Crets()
{
    int c, sx, sy, pic, angle;

    for(c=0; c<NUMCREATURES; c++)
        if(cret[c].alive == YES) {
            sx = (int)(cret[c].x>>8);
            sy = (int)(cret[c].y>>8);
            pic = cret[c].frame.pic[cret[c].cur_frame];
            angle = cret[c].angle;
            if(angle > ANGLE_90 && angle < ANGLE_270)
            Draw_Rot(pic, sx, sy, angle, 2);
            else
            Draw_Rot(pic, sx, sy, angle, 0);
        }
}

void Draw_Bcks()
{
}

main (int argc, char *argv[])
{
    unsigned long frames=0;
    unsigned long clicks=0;
    unsigned long now=0;
    unsigned int fps;
    int ang, pic, c1, c2, c3, num_c;

    Initialize();
    make_tables();
    read_bmaps("cret.bmp");
    load_pal("cret.PAL");
    set_pal();
now= *clock;
    srand((int)now);
    num_c = atoi(argv[1]);
    if(num_c < 2) num_c = 4;
// I don't recommend less than 4 creatures...
    Init_Crets();

    while(!key_table[ESC])
    {

        if(key_table[LEFT]) cursor_x-=3;
        if(key_table[RIGHT]) cursor_x+=3;
        if(key_table[UP]) cursor_y-=3;
        if(key_table[DOWN]) cursor_y+=3;
        if(cursor_x > 319) cursor_x = 319;
        if(cursor_y > 199) cursor_y = 199;
        if(cursor_x < 0) cursor_x = 0;
        if(cursor_y < 0) cursor_y = 0;
        Draw_Box(20, 40, 300, 190, 30);
//        Draw_Box_Fill(21, 39, 299, 190, 1);
        double_buffer[cursor_x + cursor_y*320]=100;
        Update_Crets();
        Draw_Crets();
    if(Num_Crets() < num_c)
    Make_Cret( (rand()%290)+30, 10, (rand()%10)+1, (rand()%40)+30,
               (rand()%30)+1, (rand()%30)+7, (rand()%4)+2, (rand()%4), rand()%4, 0);
        Show_Double_Buffer_V();
        if(DEBUG)
            Debug();
        Clear_Double_Buffer();
        frames++;
    }

    ShutDown();
clicks = (abs((int)(*clock - now)));
if((clicks*100)/182 != 0)
    printf("\nFrames: %d", frames);
    printf("\nClicks: %d", clicks);
if(clicks != 0)
    printf("\nFrames Per Second: %f", (float)frames/(clicks/18.2));
    printf("\n\nArtificially intelligent creatures have invaded your desktop! :)");
    printf("\n(C) 1996 by Dave Wallin.. CompuServe acc't: 70541, 1715");
}
